Codeforces Round #303 (Div. 2)E. Paths and Trees 最短路

E. Paths and Trees
time limit per test
3 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

Little girl Susie accidentally found her elder brother's notebook. She has many things to do, more important than solving problems, but she found this problem too interesting, so she wanted to know its solution and decided to ask you about it. So, the problem statement is as follows.

Let's assume that we are given a connected weighted undirected graph G = (V, E) (here V is the set of vertices, E is the set of edges). The shortest-path tree from vertex u is such graph G1 = (V, E1) that is a tree with the set of edges E1 that is the subset of the set of edges of the initial graph E, and the lengths of the shortest paths from u to any vertex to G and to G1 are the same.

You are given a connected weighted undirected graph G and vertex u. Your task is to find the shortest-path tree of the given graph from vertex u, the total weight of whose edges is minimum possible.

Input

The first line contains two numbers, n and m (1 ≤ n ≤ 3·1050 ≤ m ≤ 3·105) — the number of vertices and edges of the graph, respectively.

Next m lines contain three integers each, representing an edge — ui, vi, wi — the numbers of vertices connected by an edge and the weight of the edge (ui ≠ vi, 1 ≤ wi ≤ 109). It is guaranteed that graph is connected and that there is no more than one edge between any pair of vertices.

The last line of the input contains integer u (1 ≤ u ≤ n) — the number of the start vertex.

Output

In the first line print the minimum total weight of the edges of the tree.

In the next line print the indices of the edges that are included in the tree, separated by spaces. The edges are numbered starting from 1 in the order they follow in the input. You may print the numbers of the edges in any order.

If there are multiple answers, print any of them.

Examples
input
3 3
1 2 1
2 3 1
1 3 2
3
output
2
1 2
input
4 4
1 2 1
2 3 1
3 4 1
4 1 2
4
output
4
2 3 4
Note

In the first sample there are two possible shortest path trees:

  • with edges 1 – 3 and 2 – 3 (the total weight is 3);
  • with edges 1 – 2 and 2 – 3 (the total weight is 2);

And, for example, a tree with edges 1 – 2 and 1 – 3 won't be a shortest path tree for vertex 3, because the distance from vertex 3 to vertex 2 in this tree equals 3, and in the original graph it is 1.

题目链接:点击传送

题意:给你n个点,m条边,让你求u到所有点的都是最短路,并且使得图的总权值最小;

思路:dij+堆优化,在求最短路的时候多存两个pos,跟w,在保证最短路的情况下,使得w更小即可;

#pragma comment(linker, "/STACK:1024000000,1024000000")
#include<iostream>
#include<cstdio>
#include<cmath>
#include<string>
#include<queue>
#include<algorithm>
#include<stack>
#include<cstring>
#include<vector>
#include<list>
#include<set>
#include<map>
using namespace std;
#define ll long long
#define pi (4*atan(1.0))
#define eps 1e-14
#define bug(x)  cout<<"bug"<<x<<endl;
const int N=3e5+10,M=1e6+10,inf=2147483647;
const ll INF=1e18+10,mod=2147493647;
struct is
{
    int v,next,w,pos;
}edge[N<<1];
int head[N],edg;
void init()
{
    memset(head,-1,sizeof(head));
    edg=0;
}
void add(int u,int v,int w,int pos)
{
    edg++;
    edge[edg].v=v;
    edge[edg].w=w;
    edge[edg].pos=pos;
    edge[edg].next=head[u];
    head[u]=edg;
}
struct mmp
{
    int s,pos,w;
    ll dis;
    mmp(){}
    mmp(int ss,ll d,int p,int ww){s=ss,dis=d;pos=p;w=ww;}
    bool operator <(const  mmp &b)const
    {
        if(dis!=b.dis)
        return dis>b.dis;
        return w>b.w;
    }
};
ll ans[N],sum;
int vis[N];
priority_queue<mmp>q;
vector<int>out;
void dij(int s)
{
    ans[s]=0;
    q.push(mmp(s,0LL,0,0));
    while(!q.empty())
    {
        mmp now = q.top();
        q.pop();
        if(vis[now.s])continue;
        sum+=now.w;
        out.push_back(now.pos);
        vis[now.s]=1;
        for(int i = head[now.s]; i !=-1; i = edge[i].next)
        {
            int v=edge[i].v;
            ll w=edge[i].w;
            int p=edge[i].pos;
            if(ans[v] >=ans[now.s] + w)
            {
                q.push(mmp(v,ans[now.s]+w,p,w));
                ans[v]=ans[now.s]+w;
            }
        }
    }
}
int main()
{
    init();
    int n,m;
    scanf("%d%d",&n,&m);
    for(int i=1;i<=m;i++)
    {
        int u,v,w;
        scanf("%d%d%d",&u,&v,&w);
        add(u,v,w,i);
        add(v,u,w,i);
    }
    int s;
    scanf("%d",&s);
    for(int i=1;i<=n;i++)
        ans[i]=INF;
    dij(s);
    printf("%lld
",sum);
    sort(out.begin(),out.end());
    for(int i=1;i<out.size();i++)
        printf("%d ",out[i]);
    return 0;
}
E. Paths and Trees
time limit per test
3 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

Little girl Susie accidentally found her elder brother's notebook. She has many things to do, more important than solving problems, but she found this problem too interesting, so she wanted to know its solution and decided to ask you about it. So, the problem statement is as follows.

Let's assume that we are given a connected weighted undirected graph G = (V, E) (here V is the set of vertices, E is the set of edges). The shortest-path tree from vertex u is such graph G1 = (V, E1) that is a tree with the set of edges E1 that is the subset of the set of edges of the initial graph E, and the lengths of the shortest paths from u to any vertex to G and to G1 are the same.

You are given a connected weighted undirected graph G and vertex u. Your task is to find the shortest-path tree of the given graph from vertex u, the total weight of whose edges is minimum possible.

Input

The first line contains two numbers, n and m (1 ≤ n ≤ 3·1050 ≤ m ≤ 3·105) — the number of vertices and edges of the graph, respectively.

Next m lines contain three integers each, representing an edge — ui, vi, wi — the numbers of vertices connected by an edge and the weight of the edge (ui ≠ vi, 1 ≤ wi ≤ 109). It is guaranteed that graph is connected and that there is no more than one edge between any pair of vertices.

The last line of the input contains integer u (1 ≤ u ≤ n) — the number of the start vertex.

Output

In the first line print the minimum total weight of the edges of the tree.

In the next line print the indices of the edges that are included in the tree, separated by spaces. The edges are numbered starting from 1 in the order they follow in the input. You may print the numbers of the edges in any order.

If there are multiple answers, print any of them.

Examples
input
3 3
1 2 1
2 3 1
1 3 2
3
output
2
1 2
input
4 4
1 2 1
2 3 1
3 4 1
4 1 2
4
output
4
2 3 4
Note

In the first sample there are two possible shortest path trees:

  • with edges 1 – 3 and 2 – 3 (the total weight is 3);
  • with edges 1 – 2 and 2 – 3 (the total weight is 2);

And, for example, a tree with edges 1 – 2 and 1 – 3 won't be a shortest path tree for vertex 3, because the distance from vertex 3 to vertex 2 in this tree equals 3, and in the original graph it is 1.

原文地址:https://www.cnblogs.com/jhz033/p/6623689.html